      SUBROUTINE IS02R(N,X,U,P,Y,Y2,DX,E,R,IERR)
      DIMENSION X(2),U(2),P(2),Y(2),Y2(2),DX(2),E(2),R(6,2)
      INTEGER N,IERR,N1,N2,J1,J2,K
      REAL X,U,P,Y,Y2,DX,E,R,E0,H1,H2,H3,H4,H5,HH,R1,R2,UP,
     1VP,WP,W,W1,WW,WW1,WW2
      IERR=0
      IF(N.LT.3) GO TO 21
      N1=N-1
      DO 1 K=1,N1
      E0=X(K+1)-X(K)
      IF(E0.LE.0.) GO TO 22
      IF(P(K).LE.0.) GO TO 23
    1 CONTINUE
      N2=N-2
      WW=1.
      WW1=0.
      R(2,1)=0.
      R(3,1)=-1.
      J1=1
      H1=X(N)-X(N1)
      DO 2 K=1,N1
      J2=K+1
      H2=X(J2)-X(K)
      DX(K)=H2
      R(4,K)=1./(2.*(H1+H2)-H1*R(2,J1))
      R(2,K)=R(4,K)*H2
      R(3,K)=-R(4,K)*R(3,J1)*H1
      J1=K
      H1=H2
    2 CONTINUE
    3 DO 4 K=1,N
      Y2(K)=0.
      Y(K)=U(K)
    4 CONTINUE
    5 W=WW
      W1=1.-W
      Y(N)=Y(1)
      J1=1
      R(1,1)=0.
      H1=DX(N1)
      WP=H1
      H2=DX(N2)
      UP=2.*(H1+H2)
      R1=(Y(N)-Y(N1))/H1
      R2=(Y(N1)-Y(N2))/H2
      VP=6.*(R1-R2)
      DO 7 K=1,N1
      J2=K+1
      H2=DX(K)
      R2=(Y(J2)-Y(K))/H2
      IF(K.EQ.1) GO TO 6
      UP=UP-WP*R(3,J1)
      VP=VP-WP*R(1,J1)
      WP=-R(2,J1)*WP
    6 R(1,K)=R(4,K)*(6.*(R2-R1)-H1*R(1,J1))
      J1=K
      H1=H2
      R1=R2
    7 CONTINUE
      H2=WP+H1
      H1=(VP-H2*R(1,N1))/(UP-H2*(R(2,N1)+R(3,N1)))
      R(6,N1)=H1
      IF(N1.LE.2) GO TO 9
      DO 8 J1=2,N1
      K=N-J1
      R(6,K)=R(1,K)-R(2,K)*R(6,K+1)-R(3,K)*H1
    8 CONTINUE
    9 DO 10 K=1,N1
      R(6,K)=W*R(6,K)+W1*Y2(K)
   10 CONTINUE
      R(6,N)=R(6,1)
      J1=N1
      H5=0.
      DO 11 K=1,N1
      J2=K+1
      IF(K.EQ.N1) J2=1
      HH=((R(6,J2)-R(6,K))/DX(K)-(R(6,K)-R(6,J1))/DX(J1))/
     1P(K)
      IF(W.EQ.1.) R(5,K)=-HH
      IF(W.NE.1.) R(5,K)=W*(U(K)-HH)+W1*Y(K)
      H5=H5+ABS(R(5,K))
      J1=K
   11 CONTINUE
      H5=1./H5
      IF(W.NE.1.) GO TO 14
      H1=0.
      H2=0.
      DO 12 K=1,N1
      HH=Y(K)
      H1=H1+R(5,K)*HH
      H2=H2+HH*HH
   12 CONTINUE
      WW2=H1/H2
      IF(ABS(WW2-WW1).LT.5.E-4*ABS(WW2)) GO TO 13
      WW1=WW2
      GO TO 16
   13 WW=2./(1.+SQRT(1.-WW2))
      GO TO 3
   14 H2=0.
      H3=0.
      H4=0.
      DO 15 K=1,N1
      H2=H2+ABS(R(5,K)-Y(K))
      H3=H3+ABS(R(6,K))
      H4=H4+ABS(R(6,K)-Y2(K))
   15 CONTINUE
      IF(H2*H5+H4/H3.LT.5.E-4) GO TO 18
      H5=1.
   16 DO 17 K=1,N
      Y2(K)=R(6,K)
      Y(K)=R(5,K)*H5
   17 CONTINUE
      GO TO 5
   18 DO 19 K=1,N1
      Y(K)=R(5,K)
      Y2(K)=R(6,K)
   19 CONTINUE
      Y2(N)=Y2(1)
      Y(N)=Y(1)
      P(N)=P(1)
      E(1)=0.
      E(2)=P(N)*(Y(N)-U(N))**2
      E0=P(N)
      DO 20 K=1,N1
      E(1)=E(1)+DX(K)*(Y2(K+1)**2+Y2(K+1)*Y2(K)+Y2(K)**2)
      E(2)=E(2)+P(K)*(Y(K)-U(K))**2
      E0=E0+P(K)
   20 CONTINUE
      E(1)=E(1)/3.
      E(2)=E(2)/E0
      GO TO 25
   21 IERR=65
      GO TO 24
   22 IERR=66
      GO TO 24
   23 IERR=67
   24 CONTINUE
      CALL UTIS10(IERR,8)
   25 RETURN
      END
